////////////////////////////////////////////////////////////////////////////////////
//
// main.cpp
//
// Copyright (C) 2000 YUGA. All rights reserved.
//
/*
 * $Log: main.cpp,v $
 * Revision 1.24  2001/01/20 07:40:17  syou
 * - Í̍ہAToACcABcc̃AhXDefault RecipientƂĈ悤ɂA
 *   ܂Cӂ̌JgĈÍł悤ɂB܂ADefault Recipient
 *   Default Private Key̒ǉ\ɂIvV݂BA
 *   ͂Ȃr(^^;
 *
 * Revision 1.22  2000/11/23 07:17:58  syou
 * - DllMainŎqXbh쐬Ă߁APGPB2[hĂȂԂŁA
 *   B2̃vOC̑I_CAOJƂAB2ƂɗĂ
 *   oOCBWindows98ŏ؂̃bZ[WpƂȂĂ̂C
 *   BlXg`ɂȂĂPGP/MIME[̕ƌ؂肭oȂ
 *   oOPgpb2::decodePgpMailPartPgpb2::decodePgpMailPart2ŏCB
 *   Decode܂̃WbŇccłB
 *   PGP/MIMEbZ[W̕ƌ؋@\ǉB،ʂɂẮAƂ肠
 *   PGPlogɕ\悤ɂ݂܂Bo̓bZ[W\[X֒ǕB
 *
 * Revision 1.21  2000/11/08 16:50:47  syou
 * - PGPlogɃbZ[Wo͂邽߂ɁAclass PGPlogVK쐬B
 *   FXKvɂȂ肻Ȃ̂ŁAclass CriticalSectionVK쐬B
 *
 * Revision 1.20  2000/11/07 15:57:20  syou
 * - PGPsdkpX[h͎ɍsĂZLeBtbNɂ镛pŁA
 *   MFCpWindow쐬Becky!AT[g邱Ƃh߂ɁAPGPB2
 *   }`XbhBāAversion 0.00.1̌ĂƂ
 *   ܂B
 *   [STLx[X̓ƎNXɕύXBsx̑̌ړI
 *   ƂāAVC++tSTLł͂ȂASTLport-4.0̗pB
 *   CO[Ů҂ɉ邽߁Aeo̓bZ[W\[Xɓ{ŏ
 *   ł̂AXɃ\[Xֈڂ͂߂Ă܂B
 *   PGP/MIMEbZ[W̌؂ƕɑΉ悤Ǝ݂iڂ͓
 *   vO\[XQƁjA،ʂ̕\@ɗǂ@v΂ȂB
 *   ACfAR[h΂肢܂B
 *
 *
 */


#pragma warning(push)
#pragma warning(disable:4101)
#pragma warning(disable:4786)


/////////////////////////////////////////////////////////////////////////////
//
#include "main.h"
#include "resource.h"
#include <string>
#include "Config.h"
#include "Hook.h"


/////////////////////////////////////////////////////////////////////////////
//
HINSTANCE hInstance = NULL;
DWORD tlsid = NULL;
B2API* b2api = NULL;
B2APIEx* b2apiex = NULL;
PGPlog* pgplog = NULL;
Pgpb2Thread* pgpb2Thread = NULL;
stringfr* mes = NULL;
ConfigMgr* configMgr = NULL;



/////////////////////////////////////////////////////////////////////////////
// DLL entry point
BOOL APIENTRY DllMain(HANDLE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved)
{
    hInstance = (HINSTANCE)hModule;
    switch (ul_reason_for_call)
    {
        case DLL_PROCESS_ATTACH:
            {
                // memory leak p
                _CrtSetDbgFlag(_CRTDBG_LEAK_CHECK_DF | _CRTDBG_ALLOC_MEM_DF);
                //_CrtSetBreakAlloc(41);  // Yԍ̃mێbreak

                // B2 PlugIn API 
                b2api = B2APIEx::Instance();
                if (b2api == NULL) {
                    return FALSE;
                }

                // PGPlog
                pgplog = PGPlog::Instance();
                if (pgplog == NULL) {
                    return FALSE;
                }

                // PGPsdk libs
                PGPError err = PGPsdkInit();
                if(IsPGPError(err)) {
                    return FALSE;
                }

                // PGPsdk UI libs
                err = PGPsdkUILibInit();
                if (IsPGPError(err)) {
                    return FALSE;
                }

                // TLSm
                tlsid = TlsAlloc();
                if (tlsid == TLS_OUT_OF_INDEXES) {
                    return FALSE;
                }

                // ݒǂݍ
                std::string iniFilePath(b2api->GetDataFolder());
                iniFilePath.append("\\PlugIns\\pgpb2.ini");
                configMgr = new ConfigMgr(iniFilePath);
                configMgr->load();

                // Pgpb2
                pgpb2Thread = new Pgpb2Thread(hInstance, tlsid);
                if (pgpb2Thread == NULL) {
                    return FALSE;
                }

                // bZ[W舵IuWFNg
                mes = new stringfr(hInstance);
                if (mes == NULL) {
                    return FALSE;
                }

            }
            break;
        case DLL_THREAD_ATTACH:
           break;
        case DLL_THREAD_DETACH:
            break;
        case DLL_PROCESS_DETACH:
            {
                // Pgpb2I
                pgpb2Thread->waitForThreadEnd();               
                delete pgpb2Thread;

                // I
                delete mes;

                // Tls
                TlsFree(tlsid);

                // PGPsdk UI libsI
                PGPsdkUILibCleanup();

                // PGPsdk libsI
                PGPsdkCleanup();

                // PGPlogI
                pgplog->Release();

                //
                delete configMgr;

                // B2 PlugIn API ExI
                delete b2apiex;

                // B2 PlugIn APII
                delete b2api;

            }
            break;
    }
    return TRUE;
}


/////////////////////////////////////////////////////////////////////////////////////////////
// Callbacks from Becky!

#ifdef __cplusplus
extern "C"{
#endif

////////////////////////////////////////////////////////////////////////
// Called when the program is started and the main window is created.
int WINAPI BKC_OnStart()
{
    // B2APIEx
    b2apiex = B2APIEx::InstanceEx(configMgr);
    if (b2apiex) {
        // Xbhs
        if (!pgpb2Thread->run()) {
            ::MessageBox(b2apiex->GetMainWindowHandle(), "The error occured in Pgpb2Threaed#run.", "PGPB2 - Error", MB_OK | MB_ICONERROR);
        }
    }
    // Always return 0.
    return 0;
}

////////////////////////////////////////////////////////////////////////
// Called when the main window is closing.
int WINAPI BKC_OnExit()
{
    // XbhI
    pgpb2Thread->stop();
    // Return -1 if you don't want to quit.
    return 0;
}

////////////////////////////////////////////////////////////////////////
// Called when menu is intialized.
int WINAPI BKC_OnMenuInit(HWND hWnd, HMENU hMenu, int nType)
{
    switch (nType) {
    case BKC_MENU_MAIN:
        {
            // c[j[擾
            HMENU hSubMenu = CreatePopupMenu();
            int count = GetMenuItemCount(hMenu);
            InsertMenu(hMenu, count - 1 , MF_BYPOSITION | MF_STRING | MF_POPUP, reinterpret_cast<UINT>(hSubMenu), "PGPB2(&P)");
            //AppendMenu(hMenu, MF_STRING | MF_POPUP, reinterpret_cast<UINT>(hSubMenu), "PGPB2(&P)");

            // ---------- j[̒ǉƃR[obN@\̓o^ ----------
            // ƌ؁iPGP/MIMÊ݁j
            UINT nID = b2api->RegisterCommand(mes->getsfr(44).c_str(), nType, DecodePgpMime); //"PGPbZ[W̕ƌ (PGP/MIME ̂)"
            AppendMenu(hSubMenu, MF_STRING, nID, mes->getsfr(46).c_str()); //"PGPB2: ƌ (PGP/MIME ̂)..."
            // ƌ؁iPGP/MIMEȊOj
            nID = b2api->RegisterCommand(mes->getsfr(45).c_str(), nType, DecodeNotPgpMime); //"PGPbZ[W̕ƌ (PGP/MIME ȊO)"
            AppendMenu(hSubMenu, MF_STRING, nID, mes->getsfr(47).c_str()); //"PGPB2: ƌ (PGP/MIME ȊO)..."
            // Zp[^
            AppendMenu(hSubMenu, MF_SEPARATOR, 0, NULL);
            // ꎞۑpXt[Y̏
            nID = b2api->RegisterCommand(mes->getsfr(51).c_str(), nType, ClearPassphraseCache); //"PGPB2ɂ..."
            AppendMenu(hSubMenu, MF_STRING, nID, mes->getsfr(52).c_str()); //"PGPB2ɂ..."
            // About PGPB2
            nID = b2api->RegisterCommand(mes->getsfr(49).c_str(), nType, AboutPGPB2); //"PGPB2ɂ..."
            AppendMenu(hSubMenu, MF_STRING, nID, mes->getsfr(50).c_str()); //"PGPB2ɂ..."
            /*
            // Hook Start
            nID = b2api->RegisterCommand("Hook Start", nType, HookStart);
            AppendMenu(hSubMenu, MF_STRING, nID, "Hook Start");
            // Hook End
            nID = b2api->RegisterCommand("Hook End", nType, HookEnd);
            AppendMenu(hSubMenu, MF_STRING, nID, "Hook End");
            //*/
        }
        break;
    case BKC_MENU_LISTVIEW:
        break;
    case BKC_MENU_TREEVIEW:
        break;
    case BKC_MENU_MSGVIEW:
        break;
    case BKC_MENU_MSGEDIT:
        break;
    case BKC_MENU_COMPOSE:
        {
            // c[j[擾
            HMENU hSubMenu = CreatePopupMenu();
            int count = GetMenuItemCount(hMenu);
            InsertMenu(hMenu, count - 1, MF_BYPOSITION | MF_STRING | MF_POPUP, reinterpret_cast<UINT>(hSubMenu), "PGPB2(&P)");
            //AppendMenu(hMenu, MF_STRING | MF_POPUP, reinterpret_cast<UINT>(hSubMenu), "PGPB2(&P)");

            // ---------- j[̒ǉƃR[obN@\̓o^ ----------
            // Í
            UINT nID = b2api->RegisterCommand(mes->getsfr(36).c_str(), nType, Encrypt); //"PGPÍ"
            AppendMenu(hSubMenu, MF_STRING, nID, mes->getsfr(40).c_str()); //"PGPB2: Í..."
            // 
            nID = b2api->RegisterCommand(mes->getsfr(37).c_str(), nType, Sign); //"PGP"
            AppendMenu(hSubMenu, MF_STRING, nID, mes->getsfr(41).c_str()); //"PGPB2: ..."
            // ƈÍ
            nID = b2api->RegisterCommand(mes->getsfr(38).c_str(), nType, EncryptAndSign); //"PGPƈÍ"
            AppendMenu(hSubMenu, MF_STRING, nID, mes->getsfr(42).c_str()); //"PGPB2: ƈÍ..."
            // JYt
            nID = b2api->RegisterCommand(mes->getsfr(39).c_str(), nType, AttachePublicKey); //"PGPJYt"
            AppendMenu(hSubMenu, MF_STRING, nID, mes->getsfr(43).c_str()); //"PGPB2: J̓Yt..."
        }
        break;
    case BKC_MENU_COMPEDIT:
        break;
    case BKC_MENU_COMPREF:
        break;
    default:
        break;
    }
    // Always return 0.
    return 0;
}

////////////////////////////////////////////////////////////////////////
// Called when a folder is opened.
int WINAPI BKC_OnOpenFolder(LPCTSTR lpFolderID)
{
    Invalidate();

    // Always return 0.
    return 0;
}

////////////////////////////////////////////////////////////////////////
// Called when a mail is selected.
int WINAPI BKC_OnOpenMail(LPCTSTR lpMailID)
{
    Invalidate();

    // Always return 0.
    return 0;
}

////////////////////////////////////////////////////////////////////////
// Called every minute.
int WINAPI BKC_OnEveryMinute()
{
    // Always return 0.
    return 0;
}

////////////////////////////////////////////////////////////////////////
// Called when a compose windows is opened.
int WINAPI BKC_OnOpenCompose(HWND hWnd, int nMode/* See COMPOSE_MODE_* in BeckyApi.h */)
{
    // Always return 0.
    return 0;
}

////////////////////////////////////////////////////////////////////////
// Called when the composing message is saved.
int WINAPI BKC_OnOutgoing(HWND hWnd, int nMode/* 0:SaveToOutbox, 1:SaveToDraft, 2:SaveToReminder*/)
{
    // Return -1 if you do not want to send it yet.
    return 0;
}

////////////////////////////////////////////////////////////////////////
// Called when a key is pressed.
int WINAPI BKC_OnKeyDispatch(HWND hWnd, int nKey/* virtual key code */, int nShift/* Shift state. 0x40=Shift, 0x20=Ctrl, 0x60=Shift+Ctrl, 0xfe=Alt*/)
{
    // Return TRUE if you want to suppress subsequent command associated to this key.
    return 0;
}

////////////////////////////////////////////////////////////////////////
// Called when a message is retrieved and saved to a folder
int WINAPI BKC_OnRetrieve(LPCTSTR lpMessage/* Message source*/, LPCTSTR lpMailID/* Mail ID*/)
{
    // Always return 0.
    return 0;
}

////////////////////////////////////////////////////////////////////////
// Called when a message is spooled
int WINAPI BKC_OnSend(LPCTSTR lpMessage/* Message source */)
{
    // Always return 0.
    return 0;
}

////////////////////////////////////////////////////////////////////////
// Called when all messages are retrieved
int WINAPI BKC_OnFinishRetrieve(int nNumber/* Number of messages*/)
{
    // Always return 0.
    return 0;
}


////////////////////////////////////////////////////////////////////////
// Called when plug-in setup is needed.
int WINAPI BKC_OnPlugInSetup(HWND hWnd)
{
    // Return nonzero if you have processed.
    // return 1;
    int nRC = DialogBox(hInstance,
            MAKEINTRESOURCE(IDD_PGPB2_SETUP), hWnd, (DLGPROC)PGPB2SetupProc);
    return 1;
}


////////////////////////////////////////////////////////////////////////
// Called when plug-in information is being retrieved.
typedef struct tagBKPLUGININFO
{
    char szPlugInName[80]; // Name of the plug-in
    char szVendor[80]; // Name of the vendor
    char szVersion[80]; // Version string
    char szDescription[256]; // Short description about this plugin
} BKPLUGININFO, *LPBKPLUGININFO;


int WINAPI BKC_OnPlugInInfo(LPBKPLUGININFO lpPlugInInfo)
{
    /* You MUST specify at least szPlugInName and szVendor.
       otherwise Becky! will silently ignore your plug-in.*/
    strcpy(lpPlugInInfo->szPlugInName, "PGPB2");
    strcpy(lpPlugInInfo->szVendor, "YUGA");
    strcpy(lpPlugInInfo->szVersion, mes->getsfr(32).c_str()); //"version x.xx.x"
    strcpy(lpPlugInInfo->szDescription, mes->getsfr(35).c_str()); //"B2GUIPGPvOCłBPGP version 6.5.x ɑΉ܂B"
    // Always return 0.
    return 0;
}


#ifdef __cplusplus
}
#endif


////////////////////////////////////////////////////////////////////////
// j[nh
/**
 * Í
 */
void WINAPI Encrypt(HWND hWnd, LPARAM lParam)
{
    LPSTR text = NULL;
    PgpMail *mail = NULL;

    // ݂̃[\[X烁[IuWFNg\z
    LPSTR source = b2api->CompGetSource(hWnd);
    mail = new PgpMail();
    mail->fromString(source);
    b2api->Free(source);

    // ݂̃[eLXg擾āA[IuWFNgɐݒ
    char szMimeType[80];
    char szCharset[80];
    b2api->CompGetCharSet(hWnd, szCharset, 80);
    text = b2api->CompGetText(hWnd, szMimeType, 80);
    mail->setTextWithJpnProc(text, szCharset);

    // Í
    if (!pgpb2Thread->pgpEncrypt(hWnd, mail)) {
        b2api->SetMessageText(hWnd, mes->getsfr(48).c_str()); //"xɕPGP͏o܂"
    }

    // 
    if (text) {
        b2api->Free(text);
    }
}


/**
 * 
 */
void WINAPI Sign(HWND hWnd, LPARAM lParam)
{
    LPSTR text = NULL;
    PgpMail *mail = NULL;

    // ݂̃[\[X烁[IuWFNg\z
    LPSTR source = b2api->CompGetSource(hWnd);
    if (!source) {
        return;
    }
    mail = new PgpMail();
    mail->fromString(source);
    b2api->Free(source);

    // ݂̃[eLXg擾āA[IuWFNgɐݒ
    char szMimeType[80];
    char szCharset[80];
    b2api->CompGetCharSet(hWnd, szCharset, 80);
    text = b2api->CompGetText(hWnd, szMimeType, 80);
    mail->setTextWithJpnProc(text, szCharset);

    /*
    // DebugpR[h
    FILE* fp;
    string text(b2api->CompGetSource(hWnd));
    fp = fopen("E:\\syou\\mail0.txt", "wb");
    fwrite(text.c_str(), text.size(), 1, fp);
    fclose(fp);
    //*/

    // 
    if (!pgpb2Thread->pgpSigning(hWnd, mail)) {
        b2api->SetMessageText(hWnd, mes->getsfr(48).c_str()); //"xɕPGP͏o܂"
    }

    // 
    if (text) {
        b2api->Free(text);
    }
}


/**
 * ƈÍ
 */
void WINAPI EncryptAndSign(HWND hWnd, LPARAM lParam)
{
    PgpMail *mail = NULL;
    LPSTR text = NULL;

    // ݂̃[\[X烁[IuWFNg\z
    LPSTR source = b2api->CompGetSource(hWnd);
    if (!source) {
        return;
    }

    mail = new PgpMail();
    mail->fromString(source);
    b2api->Free(source);

    // ݂̃[eLXg擾āA[IuWFNgɐݒ
    char szMimeType[80];
    char szCharset[80];
    text = b2api->CompGetText(hWnd, szMimeType, 80);
    b2api->CompGetCharSet(hWnd, szCharset, 80);
    mail->setTextWithJpnProc(text, szCharset);

    // ƈÍ
    if (!pgpb2Thread->pgpEncryptSigning(hWnd, mail)) {
        b2api->SetMessageText(hWnd, mes->getsfr(48).c_str()); //"xɕPGP͏o܂"
    }

    // 
    if (text) {
        b2api->Free(text);
    }
}


/**
 * JYt
 */
void WINAPI AttachePublicKey(HWND hWnd, LPARAM lParam)
{
    // JYt
    LPSTR text = NULL;
    PgpMail *mail = NULL;

    // ݂̃[\[X烁[IuWFNg\z
    LPSTR source = b2api->CompGetSource(hWnd);
    if (!source) {
        return;
    }

    mail = new PgpMail();
    mail->fromString(source);
    b2api->Free(source);

    // ݂̃[eLXg擾āA[IuWFNgɐݒ
    char szMimeType[80];
    char szCharset[80];
    text = b2api->CompGetText(hWnd, szMimeType, 80);
    b2api->CompGetCharSet(hWnd, szCharset, 80);
    mail->setTextWithJpnProc(text, szCharset);

    // JYt
    if (!pgpb2Thread->pgpPublickey(hWnd)) {
        b2api->SetMessageText(hWnd, mes->getsfr(48).c_str()); //"xɕPGP͏o܂"
    }
}


/**
 * ƌ؁iPGP/MIME ̂݁j
 */
void WINAPI DecodePgpMime(HWND hWnd, LPARAM lParam)
{
    // ƌ PGP MIME
    PgpMail *mail = NULL;

    // ݂̃[id擾
    LPCSTR mailid = NULL;
    mailid = b2api->GetCurrentMail();

    LPSTR source = b2api->GetSource(mailid);
    if (!source) {
        return;
    }

    mail = new PgpMail();
    mail->fromString(source);

    // ƌ؁iPGP/MIMÊ݁js
    if (!pgpb2Thread->pgpDecodePgpMime(hWnd, mail)) {
        b2api->SetMessageText(hWnd, mes->getsfr(48).c_str()); //"xɕPGP͏o܂"
    }
}


/**
 *ƌ؁iPGP MIME ȊOj
 */
void WINAPI DecodeNotPgpMime(HWND hWnd, LPARAM lParam)
{
    LPSTR text = NULL;
    PgpMail *mail = NULL;

    // ݂̃[id擾
    LPCSTR mailid = NULL;
    mailid = b2api->GetCurrentMail();

    LPSTR source = b2api->GetSource(mailid);
    if (!source) {
        return;
    }

    mail = new PgpMail();
    mail->fromString(source);

    // ݂̃[eLXg擾Đݒ
    char szMimeType[80];
    char szCharset[80];
    text = b2api->GetText(szMimeType, 80);
    b2api->GetCharSet(mailid, szCharset, 80);
    mail->setTextWithJpnProc(text, szCharset);

    // ƌ؁iPGP/MIMEȊOjs
    if (!pgpb2Thread->pgpDecodeNotPgpMime(hWnd, mail)) {
        b2api->SetMessageText(hWnd, mes->getsfr(48).c_str()); //"xɕPGP͏o܂"
    }

    // 
    if (text) {
        b2api->Free(text);
    }
}


// ꎞۑpXt[Y
void WINAPI ClearPassphraseCache(HWND hWnd, LPARAM lParam)
{
    if (!pgpb2Thread->pgpClearPassphraseCache(hWnd)) {
        b2api->SetMessageText(hWnd, mes->getsfr(48).c_str());
    }
}


// About PGPB2
void WINAPI AboutPGPB2(HWND hWnd, LPARAM lParam)
{
    int nRC = DialogBox(hInstance,
            MAKEINTRESOURCE(IDD_PGPB2_ABOUT), hWnd, (DLGPROC)PGPB2AboutProc);
}


////////////////////////////////////////////////////////////////////////
//
#include <commctrl.h>

BOOL CALLBACK PGPB2SetupProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    switch (msg){
    case WM_COMMAND:
        {
            if (LOWORD(wParam) == IDOK) {
                Config config = configMgr->get();
                bool encryptDefaultKey;
                bool saveDecryptPassphrase;
                bool saveSignPassphrase;
                SYSTEMTIME stDecrypt;
                SYSTEMTIME stSign;

                encryptDefaultKey = (::SendDlgItemMessage(hWnd, IDC_ENCRYPT_DEFAULTKEY, BM_GETCHECK, 0, 0) == BST_CHECKED)? true:false;
                saveDecryptPassphrase = (::SendDlgItemMessage(hWnd, IDC_SAVE_DECRYPT_PASS, BM_GETCHECK, 0, 0) == BST_CHECKED)? true:false;
                saveSignPassphrase = (::SendDlgItemMessage(hWnd, IDC_SAVE_SIGN_PASS, BM_GETCHECK, 0, 0) == BST_CHECKED)? true:false;
                ::SendDlgItemMessage(hWnd, IDC_SAVE_DECRYPT_PASS_TIMEPICKER, DTM_GETSYSTEMTIME, GDT_VALID, reinterpret_cast<LPARAM>(&stDecrypt));
                ::SendDlgItemMessage(hWnd, IDC_SAVE_SIGN_PASS_TIMEPICKER, DTM_GETSYSTEMTIME, GDT_VALID, reinterpret_cast<LPARAM>(&stSign));

                config.setEncryptDefaultKey(encryptDefaultKey);
                config.setSaveDecryptPassphrase(saveDecryptPassphrase);
                config.setSaveSignPassphrase(saveSignPassphrase);
                config.setSaveTimeDecryptPassphrase(stDecrypt);
                config.setSaveTimeSignPassphrase(stSign);

                configMgr->set(config);
                configMgr->save();

                EndDialog(hWnd, IDOK);
            } else if (LOWORD(wParam) == IDCANCEL) {
                EndDialog(hWnd, IDCANCEL);
            } else if (LOWORD(wParam) == IDC_SAVE_DECRYPT_PASS) {
                BOOL enable = ::SendDlgItemMessage(hWnd, IDC_SAVE_DECRYPT_PASS, BM_GETCHECK, 0, 0);
                ::SendDlgItemMessage(hWnd, IDC_SAVE_DECRYPT_PASS_TIMEPICKER, WM_ENABLE, enable, 0);
            } else if (LOWORD(wParam) == IDC_SAVE_SIGN_PASS) {
                BOOL enable = ::SendDlgItemMessage(hWnd, IDC_SAVE_SIGN_PASS, BM_GETCHECK, 0, 0);
                ::SendDlgItemMessage(hWnd, IDC_SAVE_SIGN_PASS_TIMEPICKER, WM_ENABLE, enable, 0);
            }

            return TRUE;
        }

        break;

    case WM_INITDIALOG:
        {
            Config config = configMgr->get();
            BOOL encryptDefaultKey = config.isEncryptDefaultKey() ? TRUE:FALSE;
            BOOL saveDecryptPassphrase = config.isSaveDecryptPassphrase() ? TRUE:FALSE;
            BOOL saveSignPassphrase = config.isSaveSignPassphrase() ? TRUE:FALSE;
            const SYSTEMTIME& stDecrypt = config.getSaveTimeDecryptPassphrase();
            const SYSTEMTIME& stSign = config.getSaveTimeSignPassphrase();

            ::SendDlgItemMessage(hWnd, IDC_ENCRYPT_DEFAULTKEY, BM_SETCHECK, encryptDefaultKey, 0);
            ::SendDlgItemMessage(hWnd, IDC_SAVE_DECRYPT_PASS, BM_SETCHECK, saveDecryptPassphrase, 0);
            ::SendDlgItemMessage(hWnd, IDC_SAVE_DECRYPT_PASS_TIMEPICKER, DTM_SETSYSTEMTIME, GDT_VALID, reinterpret_cast<LPARAM>(&stDecrypt));
            ::SendDlgItemMessage(hWnd, IDC_SAVE_DECRYPT_PASS_TIMEPICKER, DTM_SETFORMAT, 0, reinterpret_cast<LPARAM>("HH : mm : ss"));
            ::SendDlgItemMessage(hWnd, IDC_SAVE_DECRYPT_PASS_TIMEPICKER, WM_ENABLE, saveDecryptPassphrase, 0);
            ::SendDlgItemMessage(hWnd, IDC_SAVE_SIGN_PASS, BM_SETCHECK, saveSignPassphrase, 0);
            ::SendDlgItemMessage(hWnd, IDC_SAVE_SIGN_PASS_TIMEPICKER, DTM_SETSYSTEMTIME, GDT_VALID, reinterpret_cast<LPARAM>(&stSign));
            ::SendDlgItemMessage(hWnd, IDC_SAVE_SIGN_PASS_TIMEPICKER, DTM_SETFORMAT, 0, reinterpret_cast<LPARAM>("HH : mm : ss"));
            ::SendDlgItemMessage(hWnd, IDC_SAVE_SIGN_PASS_TIMEPICKER, WM_ENABLE, saveSignPassphrase, 0);

            return TRUE;
        }
        break;

    default:
        break;
    }

    return FALSE;
}


////////////////////////////////////////////////////////////////////////
//
BOOL CALLBACK PGPB2AboutProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    switch (msg){
    case WM_COMMAND:
        {
            if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) {
                EndDialog(hWnd, IDOK);
            }

            return TRUE;
        }

        break;

    case WM_INITDIALOG:
        {
            const char* url = "http://www.ops.dti.ne.jp/~yuga/koubou/pgpb2.html";
            ::SendDlgItemMessage(hWnd, IDC_EDIT_URL, WM_SETTEXT, 0, reinterpret_cast<long>(url));
            return TRUE;
        }
        break;

    default:
        break;
    }

    return FALSE;
}


////////////////////////////////////////////////////////////////////////
//
#pragma warning(pop) /* restore previous warning */
